PROGRAM HPF_TEST

real a, aa(100), bb(100), cc(100, 100), dd(100, 100)
PROCESSORS p1, p(100), pp(100, 100)
TEMPLATE t(100), tt(100, 100)
DYNAMIC dd, cc

DISTRIBUTE onto p :: bb
!C1.6
DISTRIBUTE onto pp :: bb

DISTRIBUTE (BLOCK, BLOCK) onto pp :: cc
!C1.4
DISTRIBUTE (BLOCK, BLOCK, *) onto pp :: cc
!C1.5
DISTRIBUTE (BLOCK, *) onto pp :: cc
!C1.7
DISTRIBUTE * onto * :: cc

ALIGN aa(I) with bb(I)
!C2.3
ALIGN a(I) with p1(I)
!C2.4
ALIGN aa(I, J) with cc(I, J)
!C2.9
ALIGN aa(I) with bb(I*I)
!C2.13
ALIGN aa(I) with bb(I*1.5)

!C2.1
DISTRIBUTE onto p :: aa
!C1.2
ALIGN with dd :: cc

! execution part

! C2.2
REALIGN aa(I) with bb(I)
! C2.8
REALIGN with *cc :: dd
! C1.3
REDISTRIBUTE (CYCLIC) onto p :: bb
! C1.8
REDISTRIBUTE * onto * :: cc

END PROGRAM


